'use strict';

var table = require('./base-table');
var varint = require('varint');

exports = module.exports;

exports.addPrefix = function (multicodecStrOrCode, data) {
  var pfx = void 0;

  if (Buffer.isBuffer(multicodecStrOrCode)) {
    pfx = multicodecStrOrCode;
  } else {
    if (table[multicodecStrOrCode]) {
      pfx = table[multicodecStrOrCode];
    } else {
      throw new Error('multicodec not recognized');
    }
  }
  return Buffer.concat([pfx, data]);
};

exports.rmPrefix = function (data) {
  varint.decode(data);
  return data.slice(varint.decode.bytes);
};

exports.getCodec = function (prefixedData) {
  var v = varint.decode(prefixedData);
  var code = new Buffer(v.toString(16), 'hex');
  var codec = void 0;

  Object.keys(table).forEach(function (mc) {
    if (code.equals(table[mc])) {
      codec = mc;
    }
  });

  return codec;
};